﻿<%@ Page Title="" Language="C#" MasterPageFile="~/MIT.master" %>

<script runat="server">
    void bt1_ButtonClicked(Object sender, EventArgs e)
    {
        FormView1.DataBind();
    }

    protected void FormView2_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        FormView1.DataBind();
        GridView1.DataBind();
        FormView2.DataBind();
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        GridView1.DataBind();
    }

    protected void FormView2_ItemDeleted(object sender, FormViewDeletedEventArgs e)
    {
        FormView1.DataBind();
        GridView1.DataBind();
        FormView2.DataBind();
    }

    protected void FormView2_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        FormView1.DataBind();
        GridView1.DataBind();
        FormView2.DataBind();
    }
</script>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <form id="form1" runat="server">
        <h2>Place Order</h2><br />

       <p>Please enter your customer ID: 
           <asp:TextBox ID="txt1" runat="server" Text="" Width="150px"></asp:TextBox>
           <asp:Button ID="bt1" runat="server" Text="Enter" OnClick="bt1_ButtonClicked"/>
       </p><br />
       <h3>1. Orders (Click "New" to create an new order)</h3>
        <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:AircraftPartsConnectionString %>" 
            InsertCommand="INSERT INTO [OrderHeader] ([OrderStatus], [DatePlaced], [TotalCost], [CreditCardOrPO], [CertNo], [Mode], [CustomerID], [Comments]) VALUES ('Incomplete', GETDATE(), 0, NULL, NULL, NULL, @CustomerID, @Comments)"
             SelectCommand="SELECT TOP 1 * FROM OrderHeader WHERE CustomerID = @CustomerID ORDER BY OrderID DESC" >
            <InsertParameters>
                <asp:Parameter Name="CustomerID" Type="Int32" />
                <asp:Parameter Name="Comments" Type="String" />
            </InsertParameters>
            <SelectParameters>
                <asp:ControlParameter ControlID="txt1" Name="CustomerID" PropertyName="Text" />
            </SelectParameters>
        </asp:SqlDataSource>
        <asp:FormView ID="FormView1" runat="server" DataKeyNames="OrderID" DataSourceID="SqlDataSource2" OnItemInserted="FormView1_ItemInserted" >
            <InsertItemTemplate>
                CustomerID:
                <asp:TextBox ID="CustomerIDTextBox" runat="server" Text='<%# Bind("CustomerID") %>' />
                <br />
                Comments:
                <asp:TextBox ID="CommentsTextBox" runat="server" Text='<%# Bind("Comments") %>' />
                <br />
                <asp:LinkButton ID="InsertButton" runat="server" CausesValidation="True" CommandName="Insert" Text="Insert" />
                &nbsp;<asp:LinkButton ID="InsertCancelButton" runat="server" CausesValidation="False" CommandName="Cancel" Text="Cancel" />
            </InsertItemTemplate>
            <ItemTemplate>
                OrderID:
                <asp:Label ID="OrderIDLabel" runat="server" Text='<%# Eval("OrderID") %>' />
                <br />
                OrderStatus:
                <asp:Label ID="OrderStatusLabel" runat="server" Text='<%# Bind("OrderStatus") %>' />
                <br />
                DatePlaced:
                <asp:Label ID="DatePlacedLabel" runat="server" Text='<%# Bind("DatePlaced") %>' />
                <br />
                TotalCost:
                <asp:Label ID="TotalCostLabel" runat="server" Text='<%# Bind("TotalCost") %>' />
                <br />
                CreditCardOrPO:
                <asp:Label ID="CreditCardOrPOLabel" runat="server" Text='<%# Bind("CreditCardOrPO") %>' />
                <br />
                CertNo:
                <asp:Label ID="CertNoLabel" runat="server" Text='<%# Bind("CertNo") %>' />
                <br />
                Mode:
                <asp:Label ID="ModeLabel" runat="server" Text='<%# Bind("Mode") %>' />
                <br />
                CustomerID:
                <asp:Label ID="CustomerIDLabel" runat="server" Text='<%# Bind("CustomerID") %>' />
                <br />
                Comments:
                <asp:Label ID="CommentsLabel" runat="server" Text='<%# Bind("Comments") %>' />
                <br />
                <asp:LinkButton ID="NewButton" runat="server" CausesValidation="False" CommandName="New" Text="New" />
            </ItemTemplate>
        </asp:FormView>
        <br />
       
       <h3>2. Order Detail (Select an order detail to update/delete)</h3>
           <asp:SqlDataSource ID="SqlDataSource3" runat="server" ConnectionString="<%$ ConnectionStrings:AircraftPartsConnectionString %>" SelectCommand="SELECT [PMAHolder], [PartNbr], [QuantityOrdered], [CurrentPrice], [QuantityShipped] FROM [OrderDetail] WHERE [OrderID] = (SELECT MAX([OrderID]) FROM [OrderHeader] WHERE [CustomerID] = @CustomerID)">
           <SelectParameters>
               <asp:ControlParameter ControlID="txt1" Name="CustomerID" PropertyName="Text" Type="Int32" />
           </SelectParameters>
           </asp:SqlDataSource>

        <asp:GridView ID="GridView1" runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="PartNbr, PMAHolder" DataSourceID="SqlDataSource3">
            <Columns>
                <asp:CommandField ShowSelectButton="True" />
                <asp:BoundField DataField="PartNbr" HeaderText="PartNbr" ReadOnly="True" SortExpression="PartNbr" />
                <asp:BoundField DataField="PMAHolder" HeaderText="PMAHolder" ReadOnly="True" SortExpression="PMAHolder" />
                <asp:BoundField DataField="QuantityOrdered" HeaderText="QuantityOrdered" SortExpression="QuantityOrdered" />
                <asp:BoundField DataField="CurrentPrice" HeaderText="CurrentPrice" SortExpression="CurrentPrice" />
                <asp:BoundField DataField="QuantityShipped" HeaderText="QuantityShipped" SortExpression="QuantityShipped" />
            </Columns>
        </asp:GridView>
        <br />
        <br />

        <h3>3. View, add, or edit line items</h3>
        <asp:SqlDataSource ID="SqlDataSource4" runat="server" ConnectionString="<%$ ConnectionStrings:AircraftPartsConnectionString %>" 
            DeleteCommand="DELETE FROM [OrderDetail] WHERE [OrderID] = @OrderID AND [PMAHolder] = @PMAHolder AND [PartNbr] = @PartNbr
                           UPDATE [OrderHeader] 
                           SET [TotalCost] = (SELECT SUM([QuantityOrdered] * [CurrentPrice])*1.07 FROM [OrderDetail] WHERE [OrderID] = @OrderID) WHERE [OrderID] = @OrderID" 
            InsertCommand="INSERT INTO [OrderDetail] ([OrderID], [PMAHolder], [PartNbr], [QuantityOrdered], [CurrentPrice], [QuantityShipped]) 
                           VALUES ((SELECT MAX([OrderID]) FROM [OrderHeader] WHERE [CustomerID] = @CustomerID), @PMAHolder, @PartNbr, @QuantityOrdered, (SELECT [Price] FROM ReplPart WHERE [PartNumber] = @PartNbr AND [PMAHolder] = @PMAHolder), 0)
                           UPDATE [OrderHeader] 
                           SET [TotalCost] = (SELECT SUM([QuantityOrdered] * [CurrentPrice])*1.07 FROM [OrderDetail] WHERE [OrderID] = (SELECT MAX([OrderID]) FROM [OrderHeader] WHERE [CustomerID] = @CustomerID)) 
                           WHERE [OrderID] = (SELECT MAX([OrderID]) FROM [OrderHeader] WHERE [CustomerID] = @CustomerID)" 
            SelectCommand="SELECT * FROM [OrderDetail] WHERE [PartNbr] = @PartNbr AND [OrderID] = (SELECT MAX([OrderID]) FROM [OrderHeader] WHERE [CustomerID] = @CustomerID)" 
            UpdateCommand="UPDATE [OrderDetail] SET [QuantityOrdered] = @QuantityOrdered WHERE [OrderID] = @OrderID AND [PMAHolder] = @PMAHolder AND [PartNbr] = @PartNbr
                           UPDATE [OrderHeader] 
                           SET [TotalCost] = (SELECT SUM([QuantityOrdered] * [CurrentPrice])*1.07 FROM [OrderDetail] WHERE [OrderID] = @OrderID) WHERE [OrderID] = @OrderID">
            <DeleteParameters>
                <asp:Parameter Name="OrderID" Type="Int32" />
                <asp:Parameter Name="PMAHolder" Type="String" />
                <asp:Parameter Name="PartNbr" Type="String" />
            </DeleteParameters>
            <InsertParameters>
                <asp:Parameter Name="PMAHolder" Type="String" />
                <asp:Parameter Name="PartNbr" Type="String" />
                <asp:Parameter Name="QuantityOrdered" Type="Int32" />
                <asp:ControlParameter ControlID="txt1" Name="CustomerID" PropertyName="Text" Type="Int32" />
            </InsertParameters>
            <SelectParameters>
                <asp:ControlParameter ControlID="GridView1" Name="PartNbr" PropertyName="SelectedValue" Type="String" />
                <asp:ControlParameter ControlID="txt1" Name="CustomerID" PropertyName="Text" Type="Int32" />
            </SelectParameters>
            <UpdateParameters>
                <asp:Parameter Name="QuantityOrdered" Type="Int32" />
                <asp:Parameter Name="CurrentPrice" Type="Decimal" />
                <asp:Parameter Name="QuantityShipped" Type="Int32" />
                <asp:Parameter Name="OrderID" Type="Int32" />
                <asp:Parameter Name="PMAHolder" Type="String" />
                <asp:Parameter Name="PartNbr" Type="String" />
            </UpdateParameters>
        </asp:SqlDataSource>
        <asp:FormView ID="FormView2" runat="server" DataKeyNames="OrderID,PMAHolder,PartNbr" DataSourceID="SqlDataSource4" OnItemInserted="FormView2_ItemInserted" OnItemDeleted="FormView2_ItemDeleted" OnItemUpdated="FormView2_ItemUpdated">
            <EditItemTemplate>
                QuantityOrdered:
                <asp:TextBox ID="QuantityOrderedTextBox" runat="server" Text='<%# Bind("QuantityOrdered") %>' />
                <br />
                <asp:LinkButton ID="UpdateButton" runat="server" CausesValidation="True" CommandName="Update" Text="Update" />
                <asp:LinkButton ID="UpdateCancelButton" runat="server" CausesValidation="False" CommandName="Cancel" Text="Cancel" />
            </EditItemTemplate>
            <InsertItemTemplate>
                PMAHolder:
                <asp:TextBox ID="PMAHolderTextBox" runat="server" Text='<%# Bind("PMAHolder") %>' />
                <br />
                PartNbr:
                <asp:TextBox ID="PartNbrTextBox" runat="server" Text='<%# Bind("PartNbr") %>' />
                <br />
                QuantityOrdered:
                <asp:TextBox ID="QuantityOrderedTextBox" runat="server" Text='<%# Bind("QuantityOrdered") %>' />
                <br />
                <asp:LinkButton ID="InsertButton" runat="server" CausesValidation="True" CommandName="Insert" Text="Insert" />
                <asp:LinkButton ID="InsertCancelButton" runat="server" CausesValidation="False" CommandName="Cancel" Text="Cancel" />
            </InsertItemTemplate>
            <EmptyDataTemplate>
                <asp:LinkButton ID="NewButton3" runat="server" CausesValidation="False" CommandName="New"  Text="Create new line item"></asp:LinkButton>
            </EmptyDataTemplate>
            <ItemTemplate>
                OrderID:
                <asp:Label ID="OrderIDLabel" runat="server" Text='<%# Eval("OrderID") %>' />
                <br />
                PMAHolder:
                <asp:Label ID="PMAHolderLabel" runat="server" Text='<%# Eval("PMAHolder") %>' />
                <br />
                PartNbr:
                <asp:Label ID="PartNbrLabel" runat="server" Text='<%# Eval("PartNbr") %>' />
                <br />
                QuantityOrdered:
                <asp:Label ID="QuantityOrderedLabel" runat="server" Text='<%# Bind("QuantityOrdered") %>' />
                <br />
                CurrentPrice:
                <asp:Label ID="CurrentPriceLabel" runat="server" Text='<%# Bind("CurrentPrice") %>' />
                <br />
                QuantityShipped:
                <asp:Label ID="QuantityShippedLabel" runat="server" Text='<%# Bind("QuantityShipped") %>' />
                <br />
                <asp:LinkButton ID="EditButton" runat="server" CausesValidation="False" CommandName="Edit" Text="Edit" />
                <asp:LinkButton ID="DeleteButton" runat="server" CausesValidation="False" CommandName="Delete" Text="Delete" />
                <asp:LinkButton ID="NewButton" runat="server" CausesValidation="False" CommandName="New" Text="New" />
            </ItemTemplate>
        </asp:FormView>
        <br /><br />

        <a href="PaymentShipping.aspx?CustomerID=<%= txt1.Text %>"><h3>Proceed to Payment!</h3></a>
   </form>
</asp:Content>

